VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsImageDrag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' declaraciones
'''''''''''''''''''''''''''

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Declare Function ScreenToClient Lib "user32" ( _
    ByVal hwnd As Long, _
    lpPoint As POINTAPI) As Long

Private Declare Sub ClipCursor Lib "user32" (lpRect As Any)

Private Declare Function ClientToScreen Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetClientRect Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpRect As RECT) As Long
Dim bMover As Boolean
 
Dim XInicio As Single
Dim Yinicio As Single

Private mLimitar As Boolean

' para recibir los eventos del picbox
''''''''''''''''''''''''''''''''''''''''''''
Private WithEvents mImage As Image
Attribute mImage.VB_VarHelpID = -1

Sub Class_Init(ElImage As Image)
    
    If Not mImage Is Nothing Then Exit Sub
    Set mImage = ElImage
End Sub

Private Sub mImage_MouseMove(Button As Integer, _
                               Shift As Integer, _
                               X As Single, Y As Single)
    If bMover Then
       
       mImage.Left = (mImage.Left + X) - XInicio
       mImage.Top = (mImage.Top + Y) - Yinicio
    End If
End Sub

Private Sub mImage_MouseDown(Button As Integer, _
                               Shift As Integer, _
                               X As Single, Y As Single)
    If Button = vbLeftButton Then
       If mLimitar Then
          Dim r1 As RECT
          Dim r2 As RECT
          Dim pt As POINTAPI
          
          With mImage
            
            Call GetClientRect(mImage.Container.hwnd, r2)
            pt.X = r2.Left
            pt.Y = r2.Top
            
            Call ClientToScreen(mImage.Container.hwnd, pt)
            r2.Left = pt.X
            r2.Top = pt.Y
            
            r1 = GetRectParent(mImage.Container.hwnd)
            r2.Bottom = r2.Top + r1.Bottom
            r2.Right = r2.Left + r1.Right
            
            Call ClipCursor(r2)
          End With
       End If
       bMover = True
       XInicio = X
       Yinicio = Y
       mImage.ZOrder 0
    End If
End Sub

Private Sub mImage_MouseUp(Button As Integer, _
                             Shift As Integer, _
                             X As Single, Y As Single)
    
On Error GoTo Error_sub
    
    bMover = False
    
    If mLimitar = False Then Exit Sub
    
    Dim anchoParent As Long
    Dim altoParent As Long
    Dim r As RECT
    r = GetRectParent(mImage.Container.hwnd)
    
    anchoParent = (r.Left + r.Right) * Screen.TwipsPerPixelX
    altoParent = (r.Top + r.Bottom) * Screen.TwipsPerPixelY
    
    'MsgBox anchoParent
    
    If mImage.Left < 0 Then
        mImage.Left = 0
    End If
    If mImage.Top < 0 Then
        mImage.Top = 0
    End If
    If (mImage.Left + mImage.Width) >= anchoParent Then
        mImage.Left = anchoParent - mImage.Width
    End If
    If (mImage.Top + mImage.Height) >= altoParent Then
        mImage.Top = altoParent - mImage.Height
    End If
    
    ClipCursor vbNull
    
Exit Sub
Error_sub:
ClipCursor vbNull
MsgBox Err.Description
    
End Sub


' devuelve el rectngulo del rea cliente ( ventana sin borde )
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function GetRectParent(lHwnd As Long) As RECT
    Dim r As RECT, pt As POINTAPI
    
    Call GetClientRect(lHwnd, r)
    
    pt.X = r.Left
    pt.Y = r.Top
    Call ClientToScreen(lHwnd, pt)
    
    GetRectParent = r
End Function

Property Get LimitarArea() As Boolean
    LimitarArea = mLimitar
End Property

Property Let LimitarArea(Value As Boolean)
    mLimitar = Value
End Property

Private Sub Class_Terminate()
    If Not mImage Is Nothing Then
       Set mImage = Nothing
    End If
    ClipCursor vbNull
End Sub



