VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLabelDrag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Declare Function ScreenToClient Lib "user32" ( _
    ByVal hwnd As Long, _
    lpPoint As POINTAPI) As Long

Private Declare Sub ClipCursor Lib "user32" (lpRect As Any)

Private Declare Function ClientToScreen Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetClientRect Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpRect As RECT) As Long
Dim bMover As Boolean
 
Dim XInicio As Single
Dim Yinicio As Single

Private mLimitar As Boolean

Private WithEvents mLabel As Label
Attribute mLabel.VB_VarHelpID = -1

Sub Class_Init(ControlLabel As Label)
    
    If Not mLabel Is Nothing Then Exit Sub
    Set mLabel = ControlLabel
End Sub

Private Sub mLabel_MouseMove(Button As Integer, _
                               Shift As Integer, _
                               X As Single, Y As Single)
    If bMover Then
       
       mLabel.Left = (mLabel.Left + X) - XInicio
       mLabel.Top = (mLabel.Top + Y) - Yinicio
    End If
End Sub

Private Sub mLabel_MouseDown(Button As Integer, _
                               Shift As Integer, _
                               X As Single, Y As Single)
    If Button = vbLeftButton Then
       If mLimitar Then
          Dim r1 As RECT
          Dim r2 As RECT
          Dim pt As POINTAPI
          
          With mLabel
            
            Call GetClientRect(mLabel.Container.hwnd, r2)
            pt.X = r2.Left
            pt.Y = r2.Top
            
            Call ClientToScreen(mLabel.Container.hwnd, pt)
            r2.Left = pt.X
            r2.Top = pt.Y
            
            r1 = GetRectParent(mLabel.Container.hwnd)
            r2.Bottom = r2.Top + r1.Bottom
            r2.Right = r2.Left + r1.Right
            
            Call ClipCursor(r2)
          End With
       End If
       bMover = True
       XInicio = X
       Yinicio = Y
       mLabel.ZOrder 0
    End If
End Sub

Private Sub mLabel_MouseUp(Button As Integer, _
                             Shift As Integer, _
                             X As Single, Y As Single)
    
On Error GoTo Error_sub
    
    bMover = False
    
    If mLimitar = False Then Exit Sub
    
    Dim anchoParent As Long
    Dim altoParent As Long
    Dim r As RECT
    r = GetRectParent(mLabel.Container.hwnd)
    
    anchoParent = (r.Left + r.Right) * Screen.TwipsPerPixelX
    altoParent = (r.Top + r.Bottom) * Screen.TwipsPerPixelY
    
    If mLabel.Left < 0 Then
        mLabel.Left = 0
    End If
    If mLabel.Top < 0 Then
        mLabel.Top = 0
    End If
    If (mLabel.Left + mLabel.Width) >= anchoParent Then
        mLabel.Left = anchoParent - mLabel.Width
    End If
    If (mLabel.Top + mLabel.Height) >= altoParent Then
        mLabel.Top = altoParent - mLabel.Height
    End If
    
    ClipCursor vbNull
    
Exit Sub
Error_sub:
ClipCursor vbNull
MsgBox Err.Description
    
End Sub


' devuelve el rectngulo del rea cliente ( ventana sin borde )
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function GetRectParent(lHwnd As Long) As RECT
    Dim r As RECT, pt As POINTAPI
    
    Call GetClientRect(lHwnd, r)
    
    pt.X = r.Left
    pt.Y = r.Top
    Call ClientToScreen(lHwnd, pt)
    
    GetRectParent = r
End Function

Property Get LimitarArea() As Boolean
    LimitarArea = mLimitar
End Property

Property Let LimitarArea(Value As Boolean)
    mLimitar = Value
End Property

Private Sub Class_Terminate()
    If Not mLabel Is Nothing Then
       Set mLabel = Nothing
    End If
    ClipCursor vbNull
End Sub





