VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShape"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Declare Function ScreenToClient Lib "user32" ( _
    ByVal hwnd As Long, _
    lpPoint As POINTAPI) As Long

Private Declare Sub ClipCursor Lib "user32" (lpRect As Any)

Private Declare Function ClientToScreen Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetClientRect Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpRect As RECT) As Long
Dim bMover As Boolean
 
Dim XInicio As Single
Dim Yinicio As Single

Private mLimitar As Boolean

Private WithEvents mForm As Form
Attribute mForm.VB_VarHelpID = -1
Private mShape As Shape

Sub Class_Init(ElForm As Form, Elshape As Shape)
    
    If Not mForm Is Nothing Then Exit Sub
    If Not mShape Is Nothing Then Exit Sub
    
    Set mForm = ElForm
    Set mShape = Elshape
End Sub

Private Sub mForm_MouseMove(Button As Integer, _
                               Shift As Integer, _
                               X As Single, Y As Single)
    If bMover Then
       DoEvents
       mShape.Left = X - XInicio
       mShape.Top = Y - Yinicio
       
    End If
End Sub

Private Sub mForm_MouseDown(Button As Integer, _
                               Shift As Integer, _
                               X As Single, Y As Single)
    If Button = vbLeftButton Then
       
       If X < mShape.Left Then Exit Sub
       If X > (mShape.Left + mShape.Width) Then Exit Sub
       If Y < mShape.Top Then Exit Sub
       If Y > (mShape.Top + mShape.Height) Then Exit Sub
          
          
       bMover = True
       XInicio = X - mShape.Left
       Yinicio = Y - mShape.Top
       mShape.ZOrder 0
    End If
End Sub

Private Sub mForm_MouseUp(Button As Integer, _
                             Shift As Integer, _
                             X As Single, Y As Single)
    
On Error GoTo Error_sub
    
    bMover = False
    
    If mLimitar = False Then Exit Sub
    
    Dim anchoParent As Long
    Dim altoParent As Long
    Dim r As RECT
    r = GetRectParent(mShape.Container.hwnd)
    
    anchoParent = (r.Left + r.Right) * Screen.TwipsPerPixelX
    altoParent = (r.Top + r.Bottom) * Screen.TwipsPerPixelY
    
    If mShape.Left < 0 Then
        mShape.Left = 0
    End If
    If mShape.Top < 0 Then
        mShape.Top = 0
    End If
    If (mShape.Left + mShape.Width) >= anchoParent Then
        mShape.Left = anchoParent - mShape.Width
    End If
    If (mShape.Top + mShape.Height) >= altoParent Then
        mShape.Top = altoParent - mShape.Height
    End If
    
    ClipCursor vbNull
    
Exit Sub
Error_sub:
ClipCursor vbNull
MsgBox Err.Description
    
End Sub


' devuelve el rectngulo del rea cliente ( ventana sin borde )
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Function GetRectParent(lHwnd As Long) As RECT
    Dim r As RECT, pt As POINTAPI
    
    Call GetClientRect(lHwnd, r)
    
    pt.X = r.Left
    pt.Y = r.Top
    Call ClientToScreen(lHwnd, pt)
    
    GetRectParent = r
End Function

Property Get LimitarArea() As Boolean
    LimitarArea = mLimitar
End Property

Property Let LimitarArea(Value As Boolean)
    mLimitar = Value
End Property

Private Sub Class_Terminate()
    If Not mShape Is Nothing Then
       Set mShape = Nothing
    End If
    ClipCursor vbNull
End Sub





